#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <SDL/SDL.h>
#include <windows.h>

#include <math.h>
#include "inc/ntree.hpp"
#include "inc/jDRP.c"

SDL_Surface *screen = NULL;

int main (int argc, char *argv[]) {
  char *msg;
  int done;
  
  if (SDL_Init (SDL_INIT_VIDEO) < 0) 
    exit (1);
  atexit (SDL_Quit);
  
  jDRP_constructor("res/density.bmp");  
  
  screen=SDL_SetVideoMode (jDRP_w,jDRP_h,16,SDL_SWSURFACE|SDL_DOUBLEBUF);
  if (!screen)
    exit(2);
    
  SDL_WM_SetCaption("jDRP demo",NULL);
  
  done = 0;
  while (!done) {
    SDL_Event event;
    while (SDL_PollEvent (&event)) {
      switch (event.type) {
        case SDL_KEYDOWN:
          break;
        case SDL_QUIT:
          done=1;
          break;
        case SDL_MOUSEBUTTONDOWN:
        
          jDRP_planTo   (event.button.x,event.button.y);        
          jDRP_routeFrom(event.button.x,event.button.y,10000.0f);
          
          break;
        default:
          break;
      }
    }
    
    SDL_Rect dst;
    dst.x=dst.y=0;	  
	  jDRP_draw(screen,dst);
	  dst.w=dst.h=1;
	  int tok;
    while (jDRP_plan.token(tok)) {
      dst.x=tok%jDRP_w;
      dst.y=tok/jDRP_w;
      SDL_FillRect(screen,&dst,0x00ff00);
    }
	  
	  SDL_Flip(screen);    
    SDL_Delay(100);
  }
  
  jDRP_destructor();  
  return 0;
}
